{
"Empirical" evaluation of register change of VGA CRT Controller:
 Port[$03D4]:=index;
 a[index]:=Port[$03D5]
(Note: index 0E/0F are cursor start/end values, therefore change)
!!! ==> these registers change in the powersaving states

1. NORMAL OPERATION
+++++++++++++++++++
index: 00 95   /
index: 01 79   / index: 02 80   / index: 03 130  / index: 04 85   /
index: 05 129  / index: 06 191  / index: 07 31   / index: 08 0    /
index: 09 79   / index: 0A 13   / index: 0B 14   / index: 0C 0    /
index: 0D 0    / index: 0E 5    / index: 0F 0    / index: 10 156  /
index: 11 142  / index: 12 143  / index: 13 40   / index: 14 31   /
index: 15 150  / index: 16 185  / index: 17 163

2. HSYNC OFF               (index$04=$FF)
+++++++++++++++++++
index: 00 95   /
index: 01 79   / index: 02 80   / index: 03 130  / index: 04 255!!!
index: 05 129  / index: 06 191  / index: 07 31   / index: 08 0    /
index: 09 79   / index: 0A 13   / index: 0B 14   / index: 0C 0    /
index: 0D 0    / index: 0E 5    / index: 0F 0    / index: 10 156  /
index: 11 142  / index: 12 143  / index: 13 40   / index: 14 31   /
index: 15 150  / index: 16 185  / index: 17 163

3. VSYNC OFF               (index$06=$0)
+++++++++++++++++++
index: 00 95   /
index: 01 79   / index: 02 80   / index: 03 130  / index: 04 85   /
index: 05 129  / index: 06 0 !!!/ index: 07 31   / index: 08 0    /
index: 09 79   / index: 0A 13   / index: 0B 14   / index: 0C 0    /
index: 0D 0    / index: 0E 7    / index: 0F 128  / index: 10 156  /
index: 11 142  / index: 12 143  / index: 13 40   / index: 14 31   /
index: 15 150  / index: 16 185  / index: 17 163

4. HSYNC+VSYNC OFF         (index$04=$FF) AND (index $06=$0)
+++++++++++++++++++
index: 00 95   /
index: 01 79   / index: 02 80   / index: 03 130  / index: 04 255!!!
index: 05 129  / index: 06 0 !!!/ index: 07 31   / index: 08 0    /
index: 09 79   / index: 0A 13   / index: 0B 14   / index: 0C 0    /
index: 0D 0    / index: 0E 7    / index: 0F 128  / index: 10 156  /
index: 11 142  / index: 12 143  / index: 13 40   / index: 14 31   /
index: 15 150  / index: 16 185  / index: 17 163
}
PROGRAM SyncOFF;
USES CRT,subdos;
{Version 1.0, 10th January 1995, J. Schmitt
 References: c't 4/1991, page 338 & Qume/Taiwan utility OFFH.COM}
VAR ch :CHAR;

PROCEDURE Beep;
BEGIN {Beep}
 msound(5000,30)
END; {Beep}

PROCEDURE EnablePortWrite;
BEGIN {EnablePortWrite}
 {Indices 0..7 of CRTC are usually write protected;
  by erasing BIT 7 of Index $11 ("Vertical-Retrace-End-Register") these
  addresses may be manipulated:}
  Port[$03D4]:=$11;
  Port[$03D5]:=Port[$03D5] AND $7F
END; {EnablePortWrite}

PROCEDURE DisablePortWrite;
BEGIN {DisablePortWrite}
 {Indices 0..7 of CRTC will be write protected by setting
  BIT 7 of Index $11 ("Vertical-Retrace-End-Register"):}
  Port[$03D4]:=$11;
  Port[$03D5]:=Port[$03D5] OR $80
END; {DisablePortWrite}

PROCEDURE KillHSync;  {only(!) HSync}
BEGIN {KillHSync}
  EnablePortWrite;
 {HsyncOFF by changing value of register $04 (=Start Horizontal Retrace Pulse):}
  Port[$03D4]:=$04;
  Port[$03D5]:=$FF;
 {VsyncON (in case <KillHSync> will be called from OFF-state):}
  Port[$03D4]:=$06;
  Port[$03D5]:=$BF;
  DisablePortWrite
END; {KillHSync}

PROCEDURE KillVSync;  {only(!) VSync}
BEGIN  {KillVSync}
  EnablePortWrite;
 {VsyncOFF by changing value of register $06 (Vertical Total):}
  Port[$03D4]:=$06;
  Port[$03D5]:=$0;
 {HsyncON (in case <KillVSync> will be called from OFF-state):}
  Port[$03D4]:=$04;
  Port[$03D5]:=$55;
  DisablePortWrite
END;  {KillVSync}

PROCEDURE KillHVSync; {OFF State}
BEGIN {KillHVSync}
  EnablePortWrite;
  Port[$03D4]:=$11;
  Port[$03D5]:=Port[$03D5] AND $7F;
 {HsyncOFF:}
  Port[$03D4]:=$04;
  Port[$03D5]:=$FF;
 {VsyncOFF:}
  Port[$03D4]:=$06;
  Port[$03D5]:=$0;
  DisablePortWrite
END; {KillHVSync}

PROCEDURE NormalOperation;
BEGIN {NormalOperation}
  EnablePortWrite;
 {HSYNC back to original:}
  Port[$03D4]:=$04;
  Port[$03D5]:=$55; {Default-value}
 {VSYNC back to original:}
  Port[$03D4]:=$06;
  Port[$03D5]:=$BF; {Default-value}
  DisablePortWrite;
 {Clocking Mode Register back to zero:}
  Port[$03C4]:=$01;
  Port[$03C5]:=$00
END; {NormalOperation}

PROCEDURE BlankVideo;
BEGIN {BlankVideo}
 {Set Bit 5 of Clocking Mode Register:}
  Port[$03C4]:=$1;
  Port[$03C5]:=Port[$03C5]OR $20
END; {BlankVideo}

PROCEDURE Menu;
BEGIN {Menu}
 ClrScr;
 Writeln('SyncOFF Version 1.0  10th January 1995   (c) Qume GmbH');
 Writeln('Utility for testing PowerSaving Monitors');
 Writeln('Use at your own risk, should not be applied to "standard"');
 Writeln('non-green monitors!');
 Writeln;
 Writeln('H .... Switch HSync OFF           (Standby Mode)');
 Writeln('V .... Switch VSync OFF           (Suspend Mode)');
 Writeln('O .... Switch HSync and VSync OFF (OFF Mode)');
 Writeln('B .... Blank Video');
 Writeln;
 Writeln('While in PowerSaving State hit any key to return to normal operation!');
 Writeln;
 Writeln('You can also execute SYNCOFF directly using the following commandline');
 Writeln('parameters: syncoff h ==> turns off HSync');
 Writeln('            syncoff v ==> turns off VSync');
 Writeln('            syncoff o ==> turns off HSync+VSync');
 Writeln('            syncoff b ==> blanks video');
 Writeln('            syncoff n ==> returns to normal operation');
 Writeln;
 Writeln('Press ESC for exit');
 charin(scancode,dumchar);
 dumchar:=upcase(dumchar)
END; {Menu}

PROCEDURE Commandlineprocessing;
BEGIN {Commandlineprocessing}
 dumstring:=ParamStr(1);
 ch:=dumstring[1];
 ch:=UpCase(ch);
 CASE ch OF
   'H' :BEGIN Beep; KillHSync  END;
   'V' :BEGIN Beep; KillVsync  END;
   'O' :BEGIN Beep; KillHVSync END;
   'B' :BEGIN Beep; BlankVideo END;
   'N' :BEGIN Beep;Delay(60);Beep; NormalOperation END;
   ELSE BEGIN
        msound(100,100);
        Writeln('Use one of the following commandline paramters only: h, v, o, b or n')
        END
   END; {CASE}
 Halt
END; {Commandlineprocessing}

BEGIN {MAIN}
  IF ParamCount>0 THEN Commandlineprocessing;
  Menu;
  WHILE dumchar<>ESC DO
   BEGIN
   CASE dumchar OF
    'H' :KillHSync;
    'V' :KillVsync;
    'O' :KillHVSync;
    'B' :BlankVideo
    END; {CASE}
   IF dumchar IN ['H','V','O','B'] THEN
    BEGIN
    beep;
    REPEAT UNTIL KeyPressed;
    beep;
    Normaloperation
    END ELSE msound(100,100);
    Menu
   END
END. {MAIN}